<%@ LANGUAGE = VBScript %>

<%
' ---------------------------------------------------------------
'
' -----------------------------------------------------
' copyright 2000 by voxeo corporation. (see LGPL.txt)
' -----------------------------------------------------
'
' v1.0 Coded in ASP
' v1.0 Coded by Shane Smith and Stephen J. Lewis
'
' This application allows you to assign up to 10 callxml applications to
' one voxeo phone number.  It is also coded in Perl, PHP, and Coldfusion.   
'
' This zip file contains the following files:				 
'     applicationswitcher.php     <---- PHP version
'     applicationswitcher.cfm     <---- ColdFusion version
'     applicationswitcher.pl      <---- Perl version
'     applicationswitcher.asp     <---- This file
'
'     applicationswitcher.ini     <---- configuration file
'
'     applicationswitcher.mdb     <---- Access 2000 Database that stores the
'                                       locations of each application
'     database-win32.inc          <---- Abstracted database routines for PHP
'                                       under Windows32 environments
'     database-linux.inc          <---- Abstracted database routines for PHP
'                                       under linux environments
'
'     LGPL.txt                    <---- opensource license agreement
'     readme.txt                  <---- Introductory file 
'
'----------------------------------------------------------------

'------------------------------------------
' Change this variable to reflect your path
'------------------------------------------

Filename = "c:\inetpub\wwwroot\jumpstart\applicationswitcher\applicationswitcher.ini"

'-------------------------------------------------------------------------------------------

function CheckTheDatabase 
  Dim TempDatabase, TempArray(20)
  
  TempSQL = "select Name,URL from Applications order by AppNum"
  set TempDatabase = TempConnection.execute(TempSQL)

  Loopy = 0
  
  while ( NOT TempDatabase.EOF )
    Loopy = Loopy + 1
    
    if (Loopy < 11) then 
      TempArray(Loopy)      = TempDatabase("Name")
      TempArray(Loopy + 10) = TempDatabase("URL")  
    end if

    TempDatabase.MoveNext
  wend  ' while loop

  CheckTheDatabase = TempArray
end function ' CheckTheDatabase function

'-------------------------------------------------------------------------------------------

function GetApplications
  Dim TempFileHandle, GetFileHandle, TextStreamHandle, FileArray(), SplitArray, TempArray(20)
  
  Set TempFileHandle = Server.CreateObject("Scripting.FileSystemObject")
  
  '-------------------------------------------------------------------------
  ' Open file for reading (the 1) and use the default file format (the -2)
  '-------------------------------------------------------------------------
  
  set GetFileHandle = TempFileHandle.GetFile(Filename)
  set TextStreamHandle = GetFileHandle.OpenAsTextStream(1, -2)
  
  '----------------------------
  ' Read the file into an array
  '----------------------------

  Loopy = 0
  
  do while not TextStreamHandle.AtEndOfStream
    Loopy = Loopy + 1
	
	'-------------------------------------------
	' Syntactically, this is not elegant, but we 
	' need to keep an "open-ended" array.
	'-------------------------------------------
	
	Redim Preserve FileArray(Loopy)
	FileArray(Loopy) = TextStreamHandle.ReadLine
  Loop
    
  '---------------
  ' Close the file
  '---------------

  TextStreamHandle.Close
  
  TotalLines = Loopy
  Key        = "applicationswitcher="
  KeyLength  = len(Key)
  Loopy      = 0

  for Loopy1 = 1 to TotalLines
	'---------------------------------------------------
	' We only want lines that do not start with a // sign
	' (which is a commented line)
	'---------------------------------------------------
	 
	Line = trim(lcase(FileArray(Loopy1)))
	 
    Position = instr(Line, "//")
	
	If ((Position = 0) OR (Position > 1)) Then
	  '--------------------------------
	  ' Make sure the line is not blank
	  '--------------------------------  
	  
	  If (Line <> "") Then
	    Position     = instr(Line, Key)
		PipePosition = instr(Line, "|")
		
		'------------------------------------------------
		' Check both for the applicationswitcher variable
		' in the INI file, and URL mappings.  
		'------------------------------------------------
		
		If (Position > 0) Then 
		  DatabaseOrTextFile = Mid(Line, Position + KeyLength)
		Elseif (PipePosition > 0) Then
          SplitArray = split(Line, "|")
		  TempName   = SplitArray(0)
		  TempURL    = SplitArray(1)
		  
		  '---------------------------------------
		  ' Make sure that is both a menu name and 
		  ' a mapped URL, otherwise ignore it.
		  '---------------------------------------
		  
		  If ((TempName <> "") AND (TempURL <> "") AND (Loopy < 10)) Then
		    Loopy = Loopy + 1
			
		    TempArray(Loopy)      = TempName
		    TempArray(Loopy + 10) = TempURL
		  End If  ' if statement
		  
		End If  ' elseif statement
	  End If  ' if statement
	End If  ' if statement
  next  

  '------------------------------------------------------------------
  ' If the user wants to use the database instead, then load the 
  ' information, otherwise default to using the INI file information.
  '------------------------------------------------------------------
  
  If (DatabaseOrTextFile = "database") Then 
    DatabaseTempArray = CheckTheDatabase
	GetApplications   = DatabaseTempArray
  Else 
    GetApplications = TempArray    
  End If
  
 
end function ' GetApplications function

'-------------------------------------------------------------------------------------------

sub MainMenu 
  TempArray    = GetApplications
  NamesText    = ""
  URLsText     = ""
  TermDigits   = ""
  NumberOfURLs = 0
  
  '------------------------------------------------------------------------------------
  ' First we determine the termdigits -- remember, we only support 10 applications here
  ' This is because the <text> element currently clears out the digit buffer.  Thus
  ' you can use termdigits, but not a <getdigits> -- otherwise, you have to listen to
  ' the entire menu list before choosing.
  '------------------------------------------------------------------------------------
  
  TotalItems = UBound(TempArray)
  if TotalItems > 10 then
    TotalItems = 10
  end if
   
  For Loopy = 1 to TotalItems
    NumberOfURLs = Loopy

	'--------------------------------------------------------------------
	' Make sure that we are not adding termdigits that shouldn't be added
	'--------------------------------------------------------------------

	  if TempArray(Loopy + 10) <> "" then
	    if (Loopy = "10") then
	      TermDigits = TermDigits & "0"
	    else
	      TermDigits = TermDigits & Loopy
	    end if
	  end if

  next ' while loop
  
  '---------------------------------------------
  ' Next we determine the Text-To-Speech message
  ' And the event handlers.
  '---------------------------------------------
  
  Loopy     = 1
  NamesText = "<text termdigits=""" & TermDigits & """>,,,,"
  
  for Loopy = 1 to NumberOfURLs
    if (Loopy = "10") then 
	  Digit = "0"  
	else
	  Digit = Loopy
	end if
	

	if TempArray(Loopy + 10) <> "" then
	  NamesText = NamesText & "For " & TempArray(Loopy) & ", press " & Digit & ",,"

          '-----------------------------------------------------------
          ' We just dynammically build our <ontermdigit> handler here.
          '-----------------------------------------------------------
	
          URLsText  = URLsText &_
	               "<ontermdigit value=""" & Digit & """>" &_
	               "  <goto value=""" & TempArray(Loopy + 10) & """ cache=""no""/>" &_
		       "</ontermdigit>"
	end if

  next  ' for loop
  
  NamesText = NamesText & "</text>"
  
  if (NumberOfURLs = "0") then
    NamesText = "<text>I'm sorry, there are currently no applications to choose from.</text>"
  end if  ' if statement
  
  '----------------------------------------------------------
  ' Here is where we actually display the entire menu, having 
  ' been created from the database.
  '----------------------------------------------------------
  
  response.write "<block label=""MainMenu"" " &_ 
		       "repeat=""3"">"
					
  response.write NamesText

  response.write URLsText		
  
  response.write "</block>"
end sub  ' MainMenu sub

'-------------------------------------------------------------------------------------------

sub Initialize() 
  response.write "<?xml version=""1.0"" encoding=""UTF-8""?>" 
  response.write "<callxml>"
end sub  ' Initialize sub

'-------------------------------------------------------------------------------------------

sub Closure() 
  response.write "</callxml>"
end sub  ' Closure sub

'-------------------------------------------------------------------------------------------

set TempConnection = Server.CreateObject("ADODB.Connection")
TempConnection.Open "ApplicationSwitcher"

Call Initialize
Call MainMenu
Call Closure

TempConnection.close
set TempConnection=nothing

%>