print "Content-type: text/html\n\n";

# ---------------------------------------------------------------
#
# -----------------------------------------------------
# copyright 2000 by voxeo corporation. (see LGPL.txt)
# -----------------------------------------------------
#
# v1.0 Coded in Perl
# v1.0 Coded by Shane Smith and Stephen J. Lewis
#
# This application allows you to assign up to 10 callxml applications to
# one voxeo phone number.  It is also coded in ASP, Perl, and Coldfusion.   
#
# This zip file contains the following files:				 
#     applicationswitcher.php     <---- PHP version
#     applicationswitcher.cfm     <---- ColdFusion version
#     applicationswitcher.asp     <---- ASP version
#     applicationswitcher.pl      <---- This file
#
#     applicationswitcher.ini     <---- configuration file
#
#     applicationswitcher.mdb     <---- Access 2000 Database that stores the
#                                       locations of each application
#     database-win32.inc          <---- Abstracted database routines for PHP
#                                       under Windows32 environments
#     database-linux.inc          <---- Abstracted database routines for PHP
#                                       under linux environments (interbase)
#
#     LGPL.txt                    <---- opensource license agreement
#     readme.txt                  <---- Introductory file 
#
#----------------------------------------------------------------


# ---------------------------------------
# Initialize the ODBC databasing routines
# ---------------------------------------

use DBI; 

@NameArray;
@URLArray;

#------------------------------------------
# Change this variable to reflect your path
#------------------------------------------

$Filename = "c:/Inetpub/wwwroot/Jumpstart/ApplicationSwitcher/ApplicationSwitcher.ini";

print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"; 
print "<callxml>";


#-------------------------------------------------------------------------------------------

sub GetApplications {
  open TempFileHandle, $Filename; 

  #----------------------------
  # Read the file into an array
  #----------------------------

  @FileArray = <TempFileHandle>;

  #---------------
  # Close the file
  #---------------

  close TempFileHandle;
  
  $Key       = "applicationswitcher=";
  $KeyLength = length($Key);  
  $Loopy = 0;

  foreach $Line(@FileArray) {
    $Line = lc($Line);
	
	#------------------------------------------------------------------------------
	# This line strips trailing spaces off of the string.  Yes, I know.  Don't ask.
	#------------------------------------------------------------------------------
	
	$Line =~ s/^\s+//g;

    $Position = index($Line, "//");
	
	if (($Position > 0) || ($Position eq -1)) {
	  #--------------------------------
	  # Make sure the line is not blank
	  #--------------------------------
	  
	  if ($Line ne "") {
	    $Position     = index($Line, $Key);
		$PipePosition = index($Line, "|");	
		
		#------------------------------------------------
		# Check both for the applicationswitcher variable
		# in the INI file, and URL mappings.  
		#------------------------------------------------
		
		if ($Position gt -1) {
		  $DatabaseOrTextFile = substr($Line, $Position + $KeyLength);
        }  # if statement
		elsif ($PipePosition gt -1) {
          ($TempName, $TempURL) = split /\|/, $Line;
	  
		  #---------------------------------------
		  # Make sure that is both a menu name and 
		  # a mapped URL, otherwise ignore it.
		  #---------------------------------------		  
		  
		  if (($TempName ne "") && ($TempURL ne "")) {
		    $Loopy++;
		    @NameArray[$Loopy] = $TempName;
		    @URLArray[$Loopy]  = $TempURL;
		  }  # if statement
		}  # elseif statement
	  }  # if statement
	}  # if statement
  }  # foreach loop
  
  #------------------------------------------------------------------
  # If the user wants to use the database instead, then load the 
  # information, otherwise default to using the INI file information.
  #------------------------------------------------------------------

  if (index($DatabaseOrTextFile, "database") gt -1) { &CheckTheDatabase; }
    
}  # GetApplications subroutine

# ---------------------------------------------------------------------------

sub CheckTheDatabase() {
  my $TempDatabase = DBI->connect("dbi:ODBC:ApplicationSwitcher", "", "");
  $TempSQL         = "select Name,URL from Applications order by AppNum";
  
  $TempRecordset = $TempDatabase->prepare($TempSQL);
  $TempRecordset->execute();
 
  $Loopy = 0;
 
  while ( (($Name,$URL) = $TempRecordset->fetchrow_array() )) {
    $Loopy++;
   
    @NameArray[$Loopy] = $Name;
    @URLArray[$Loopy]  = $URL;
  }  # while statement  
}  # CheckTheDatabase subroutine

#-----------------------------------------------------------------------------

  &GetApplications;

  $NamesText    = "";
  $URLsText     = "";
  $TermDigits   = "";
  $NumberOfURLs = 0;
 
  #------------------------------------------------------------------------------------
  # First we determine the termdigits -- remember, we only support 10 applications here
  # This is because the <text> element currently clears out the digit buffer.  Thus
  # you can use termdigits, but not a <getdigits> -- otherwise, you have to listen to
  # the entire menu list before choosing.
  #------------------------------------------------------------------------------------
  
  $Loopy = 1;
   
  while ((@NameArray[$Loopy] ne "") && ($Loopy < 11)) {
    $NumberOfURLs = $Loopy;

    if ($Loopy eq "10") { $TermDigits = $TermDigits . "0";    }
	else                { $TermDigits = $TermDigits . $Loopy; }
	
	$Loopy++;
  }  # while loop
 
  #---------------------------------------------
  # Next we determine the Text-To-Speech message
  # And the event handlers.
  #---------------------------------------------
  
  $Loopy     = 1;
  $NamesText = "<text termdigits=\"" . $TermDigits . "\">,,,,";
  
  while ($Loopy <= $NumberOfURLs) {
    if ($Loopy eq "10") { $Digit = "0";    }
	else                { $Digit = $Loopy; }
	
	$NamesText = $NamesText . "For " . @NameArray[$Loopy] . ", press " . $Digit . ",,";

	#-----------------------------------------------------------
    # We just dynammically build our <ontermdigit> handler here.
    #-----------------------------------------------------------
	
    $URLsText  = $URLsText . 
	             "<ontermdigit value=\"" . $Digit . "\">" .
	             "  <goto value=\"" . @URLArray[$Loopy] . "\" cache=\"no\"/>" .
				 "</ontermdigit>";
	$Loopy++;
  }  # while loop
  
  $NamesText = $NamesText . "</text>";
  
  if ($NumberOfURLs eq "0") {
    $NamesText = "<text>I'm sorry, there are currently no applications to choose from.</text>";
  }  # if statement
  
  #----------------------------------------------------------
  # Here is where we actually display the entire menu, having 
  # been created from the database.
  #----------------------------------------------------------
  
  print "<block label=\"MainMenu\" " . 
		       "repeat=\"3\">";
					
  print $NamesText;

  print $URLsText;		
  
  print "</block>";

#-----------------------------------------------------------------------------------------

print "</callxml>";